require "./AI/USER_AI/UserHead.lua"

function	GetOwnerEnemy (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then
			target = GetV (V_TARGET,v)
			if (target == owner) then
				if (IsMonster(v) == 1) then
					enemys[index] = v
					index = index+1
				else
					local motion = GetV(V_MOTION,i)
					if (motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
						enemys[index] = v
						index = index+1
					end
				end
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end
	
	return result
end





function	GetMyEnemy (myid)
	local result = 0

	local type = GetV (V_HOMUNTYPE,myid)
	if (type == LIF or type == LIF_H or type == AMISTR or type == AMISTR_H or type == LIF2 or type == LIF_H2 or type == AMISTR2 or type == AMISTR_H2) then
		result = GetMyEnemyA (myid)
	elseif (type == FILIR or type == FILIR_H or type == VANILMIRTH or type == VANILMIRTH_H or type == FILIR2 or type == FILIR_H2 or type == VANILMIRTH2 or type == VANILMIRTH_H2) then
		result = GetMyEnemyA (myid)
	end
	return result
end




-------------------------------------------
--  U^ GetMyEnemy
-------------------------------------------
function	GetMyEnemyA (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then
			target = GetV (V_TARGET,v)
			if (target == myid) then
				enemys[index] = v
				index = index+1
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	return result
end





-------------------------------------------
--  U^ GetMyEnemy
-------------------------------------------
function	GetMyEnemyB (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local type
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then
			if (1 == IsMonster(v))	then
				enemys[index] = v
				index = index+1
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	return result
end

-----------------------------------------------
-- XLgpm Zo SkillProbabilityA
-- ͂SP̎gp ꕪ
-- SP%=100 gp100%    SP%=50 gp0%
-----------------------------------------------
function	SkillProbabilityA (persp)
	math.randomseed(GetTick())
	if persp > 0.5 then
		if ((400 * persp * persp / 3) - 33) > math.random(100) then
			return true
		else 
			return false
		end
	else
		return false
	end
end

-----------------------------------------------
-- XLgpm Zo SkillProbabilityB
-- ͂SP̎gp ꕪ
-- SP%=100 gp100%    SP%=0 gp0%
-----------------------------------------------
function	SkillProbabilityB (persp)
	math.randomseed(GetTick())
	if persp > 0.5 then
		if (100 * persp * persp) > math.random(100) then
			return true
		else 
			return false
		end
	else
		return false
	end
end

------------------------------------------------------------------------
-- ԃ|Cg܂ňړ
-- idWx,y܂ňړꍇ̒ԓ_܂ňړ
------------------------------------------------------------------------
function	MoveToHalfway (id,x,y)
	local MyX, MyY =  GetV(V_POSITION, MyID)
	local HalfX = x - MyX
	local HalfY = y - MyY
	
	if (math.abs(HalfX) > 5 and HalfX < 0)
		HalfX = -5
	elseif (math.abs(HalfX) > 5 and HalfX > 0)
		HalfX = 5		
	end
	
	if (math.abs(HalfY) > 5 and HalfY < 0)
		HalfY = -5
	elseif (math.abs(HalfY) > 5 and HalfY > 0)
		HalfY = 5		
	end
	
	Move(id, MyX + HalfX, MyY + HalfY)
	
	return nil
end
